C      RANDOM NUMBER GENERATOR
C         L. SCHRAGE, ACM TRANSACT. ON MATH. SOFTWARE, VOL.5, NO 2, P.13
C                     (1979)
C
C         IX=IX*(7**5) MOD(2**31-1)
C
C         AUFRUF X=RAN(IX), IX SEED INTEGER*4,X RANDOM NUMBER, 0<X<1
C
        DOUBLE PRECISION FUNCTION RANNO(IX)
 
        INTEGER*4 A,P,IX,B15,B16,XHI,XALO,LEFTLO,FHI,K
        PARAMETER (A=16807)
        PARAMETER (B15=32768)
        PARAMETER (B16=65536)
        PARAMETER (P=2147483647)
        XHI=IX/B16
        XALO=(IX-XHI*B16)*A
        LEFTLO=XALO/B16
        FHI=XHI*A+LEFTLO
        K=FHI/B15
        IX=(((XALO-LEFTLO*B16)-P)+(FHI-K*B15)*B16)+K
        IF(IX.LT.0) IX=IX+P
        RANNO=REAL(IX)*4.65661287D-10
        RETURN
        END
