      subroutine vciput (ID1D, NLCB, NSKIP, NVTOT, LUCONIN, FCONIN,
     /                    AID, BID, VID, NL, TIME)
 
C Program used for reading the configurations from the input file
C FCONIN; the first NSKIP conf's are skipped.
C ID1D is the one dimensional array that stores the configuration.
C NLCB is the cube of linear dimension of the crystal.
C LUCONIN is the unit number of the conf. input file.
 
       INTEGER*4 NLCB, LUCONIN, NSKIP, NVTOT, NL
       INTEGER*2 AID, BID, VID
       INTEGER*2 ID1D(NLCB)
       CHARACTER*20 FCONIN
       REAL*8 TIME

       INTEGER BUFSIZ,WORDLEN,NBUF
       PARAMETER (BUFSIZ=256,WORDLEN=32)
 
       INTEGER BUFFER(BUFSIZ)
       INTEGER N, WORD, BIT, BUF, X, BITPOS
       INTEGER BUFCOMP, WORDCOMP
       INTEGER NVAC, VACLOC, I1, I2, I3
 
C Initialize.
       DO 150 X = 1, NLCB
 150	  ID1D(X) = AID
 
C Read the input configuration from a file.
c First skip N-1 conf's in this file.
       WRITE(*,*) 'READING CONFIGURATION FROM ', FCONIN
       OPEN(UNIT=LUCONIN,FILE=FCONIN,STATUS='OLD',FORM='UNFORMATTED')
       NBUF = 1 + (NLCB / (WORDLEN * BUFSIZ))
       DO 300 n = 1, NSKIP
          READ (LUCONIN, END=3333) TIME
          READ (LUCONIN, END=3333) BUFFER
          DO 290 BUF = 1,NBUF
             READ (LUCONIN, END=3333) BUFFER
 290      CONTINUE
 300   CONTINUE
 
       READ (LUCONIN, END=3333) TIME
       READ (LUCONIN, END=3333) BUFFER
C The first number is the random number; it is not needed.
       N = 2
       NVTOT = BUFFER(N)
       DO 350 NVAC = 1, NVTOT
          I1 = BUFFER(N+1)
          I2 = BUFFER(N+2)
          I3 = BUFFER(N+3)
          VACLOC = (I3 - 1) * NL * NL + (I2 - 1) * NL + I1
          ID1D(VACLOC) = VID
          IF ((VACLOC.LE.0).OR.(VACLOC.GE.NLCB)) WRITE (*,*) 'WHAT?'
          N = N+3
 350   CONTINUE
 
       DO 400 BUF = 1, NBUF
          READ (LUCONIN, END=3333) BUFFER
          BUFCOMP = (BUF - 1) * BUFSIZ * WORDLEN
          DO 390 WORD = 1, BUFSIZ
             WORDCOMP = (WORD - 1) * WORDLEN
             DO 380 BIT = 1, WORDLEN
                BITPOS = WORDLEN - BIT
                X = BUFCOMP + WORDCOMP + BIT
                IF ((X.LE.NLCB).AND.(BTEST(BUFFER(WORD), BITPOS))) 
     /             ID1D(x) = BID
 380         CONTINUE
 390      CONTINUE
 400   CONTINUE
       CLOSE (UNIT = LUCONIN)
 3333  CONTINUE
 
       WRITE (*,*) 'INITIAL CONFIGURATION DONE.'
 
       RETURN
       END


