
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        Subroutine FOURN(DATA,NN,NDIM,ISIGN,L)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Calcul d'une transformee de Fourier Rapide (FFT)         c
c  d'apres W.H.Press et B.P.Flennery: Numericals recipies   c
c          Cambridge University Press                       c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc    
        REAL*8 WR,WI,WPI,WTEMP,THETA 
        dimension DATA(L),NN(NDIM)
        NTOT=1
        Do 11 IDIM=1,NDIM
           NTOT=NTOT*NN(IDIM)
11      Continue
        NPREV=1
        Do 18 IDIM=1,NDIM
           N=NN(IDIM)
           NREM=NTOT/(N*NPREV)
           IP1=2*NPREV
           IP2=IP1*N
           IP3=IP2*NREM
           I2REV=1
           Do 14 I2=1,IP2,IP1
              If (I2.lt.I2REV) then
                 Do 13 I1=I2,I2+IP1-2,2
                    Do 12 I3=I1,IP3,IP2
                       I3REV=I2REV+I3-I2
                       TEMPR=DATA(I3)
                       TEMPI=DATA(I3+1)
                       DATA(I3)=DATA(I3REV)
                       DATA(I3+1)=DATA(I3REV+1)
                       DATA(I3REV)=TEMPR
                       DATA(I3REV+1)=TEMPI
12                  continue
13               Continue
              Endif
              IBIT=IP2/2
1             If((IBIT.ge.IP1).and.(I2REV.gt.IBIT)) then
                 I2REV=I2REV-IBIT
                 IBIT=IBIT/2
              Go to 1
              Endif 
              I2REV=I2REV+IBIT
14         Continue
           IFP1=IP1
2          IF (IFP1.LT.IP2) THEN
              IFP2=2*IFP1
              THETA=ISIGN*6.28318530717959/(IFP2/IP1)
              WPR=-2.*SIN(0.5*THETA)**2
              WPI=SIN(THETA)
              WR=1.
              WI=0.
              Do 17 I3=1,IFP1,IP1
                 Do 16 I1=I3,I3+IP1-2,2
                    Do 15 I2=I1,IP3,IFP2
                       K1=I2
                       K2=K1+IFP1
                       TEMPR=SNGL(WR)*DATA(K2)-SNGL(WI)*DATA(K2+1)
                       TEMPI=SNGL(WR)*DATA(K2+1)+SNGL(WI)*DATA(K2)
                       DATA(K2)=DATA(K1)-TEMPR
                       DATA(K2+1)=DATA(K1+1)-TEMPI
                       DATA(K1)=DATA(K1)+TEMPR
                       DATA(K1+1)=DATA(K1+1)+TEMPI
15                   Continue
16               Continue
                 WTEMP=WR
                 WR=WR*WPR-WI*WPI+WR
                 WI=WI*WPR+WTEMP*WPI+WI
17            Continue
              IFP1=IFP2
            Go to 2 
            Endif
            NPREV=N*NPREV
18      CONTINUE
        RETURN
        END

