      subroutine vcnfin5q (ID1D, NLCB, NBTOT, NVTOT, LUCONIN, FCONIN,
     /SHIFT,LORDER,IPULL,AID,BID,VID, NL1,NL2,TIME,TSTEP,LOCV,NVMX)


C    Built from vcnfini and adapted to rhirr5: Limoge ALECOM(), including NL1,NL2 
C   if NBTOT is positive and greater than 6, it represents the total number of B atoms
C  in the crystal and the initial configuration is determined randomly when shift equals 0 
C  and LORDER=1; otherwise, if shift=0 and LORDER=0 , build L10 state 
C  and if shift=0 and LORDER=2, build L12 state.

c If NBTOT equals one, build a slice of pure B in pure A ; 
c  the average composition is then 0.5/0.5.
c If NBTOT equals two, build a small rhomboedron of pure B in pure A
c  the average composition is then 1/8
c If NBTOT equals four, build a multilayer of 4 A/B sequences
c  the average composiiton is then 0.5
C If NBTOT is negative or zero, 
C  the configuration is read from an input file
C  after skipping (-NBTOT) configurations in it.
C ID1D is the one dimensional array that stores the configuration.
C NLCB is the cube of linear dimension of the crystal.
C ALECOM() is the random number function
C LUCONIN is the unit number of the conf. input file.
 
      INTEGER*4 NLCB, LUCONIN, IPULL, NBTOT, NVTOT, NL1, NL2, NVMX
      INTEGER*4 LOCV(3, NVMX), SHIFT, LORDER,NDIF
      INTEGER*2 AID, BID, VID
      
      CHARACTER*20 FCONIN
      REAL*8 TIME, TSTEP

      INTEGER*2 ID1D(NLCB)

      INTEGER BUFSIZ,WORDLEN,NBUF
      PARAMETER (BUFSIZ=256,WORDLEN=32)
      integer*4 k1,k2,k3,m1,m2,m3  
      INTEGER BUFFER(BUFSIZ)
      INTEGER N, NSKIP, WORD, BIT, BUF, X, BITPOS
      INTEGER BUFCOMP, WORDCOMP
      INTEGER NVAC, VACLOC, I1, I2, I3, AA, AA2, BB, BB2, AMPL
      REAL*8 ALECOM,RI1,RI2,XX,RNL, Pi
      DATA Pi /3.141592653589 /

      INTEGER RANG(600000)
      INTEGER*4 RN,NMX,CORE(3),N1,N2,N3, BRAN
      REAL*8 R,MAGTDE,TINY
	DATA TINY /1.d-13/

C     MODL(K1) helps find the location in the basic unit cell
C        which corresponds to those in the neighboring cells.
      INTEGER*4 MODL1(-5*NL1:5*NL1+1)
       
C Initialize.
      DO I1 = -5*NL1, 5*NL1+1
         MODL1(I1) = MOD(I1, NL1)
         IF (MODL1(I1).LE.0) MODL1(I1) = MODL1(I1) + NL1
      END DO
      
      DO 150 X = 1, NLCB
 150     ID1D(X) = AID
 
      DO 160 N = 1, NVMX
      DO 160 I1 = 1, 3
         LOCV(I1,N) = 0
 160  CONTINUE
cc    CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      IF (NBTOT.GT.100.and.shift.eq.0.and.LORDER.eq.1) THEN
         WRITE (*,*) 'RANDOM CONFIGURATION. ', NBTOT, NVTOT
C Random configuration.
         TIME = 0.0
         STEP = 0.0
         DO 200 N = 1, NBTOT + NVTOT
 199        X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1
            IF (ID1D(X).NE.AID) GOTO 199
            IF (N.LE.NBTOT) THEN
               ID1D(X) = BID
            ELSE
               ID1D(X) = VID
               I3 = (X - 1) / (NL1 * NL1)
               I2 = ((X - I3 * NL1 * NL1) - 1) / NL1 
               I1 = X - I3 * NL1 * NL1 - I2 * NL1
               LOCV(3, N - NBTOT) = I3 + 1
               LOCV(2, N - NBTOT) = I2 + 1
               LOCV(1, N - NBTOT) = I1
            END IF
 200     CONTINUE
c  CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

 
cc CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      ELSE IF ( NBTOT.GT.100.and.shift.eq.0.and.LORDER.eq.0) THEN
         write(*,*) 'L10'
         N = 1
         X = 1

         DO while(X.le. NLCB)
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1 
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            I3 = I3 + 1
            I2 = I2 + 1
            if( mod(I3+I2,2).ne.0)then
               N = N + 1
               ID1D(X) = BID
            end if
            X = X + 1
         end do
           
         NDIF=NLCB/2-NBTOT
         N=1
         IF(NDIF.GT.0)THEN
            DO WHILE(N.LE.NDIF)
               X = 1 + INT(ALECOM() * NLCB)
               IPULL = IPULL + 1
               IF (ID1D(X).EQ.BID) THEN
                  ID1D(X)=AID
                  N=N+1
               ENDIF
            ENDDO   
         ELSE
            DO WHILE(N.LE.-NDIF)
               X = 1 + INT(ALECOM() * NLCB)
               IPULL = IPULL + 1
               IF (ID1D(X).EQ.AID) THEN
                  ID1D(X)=BID
                  N=N+1
               ENDIF
            ENDDO    
         ENDIF


         DO 267 N = 1, NVTOT
 257        X = 1 + INT(ALECOM() * NLCB)
         IPULL = IPULL + 1 
         IF (ID1D(X).NE.AID) GOTO 257
            ID1D(X) = VID
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1 
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            LOCV(3, N) = I3 + 1
            LOCV(2, N) = I2 + 1
            LOCV(1, N) = I1
 267     CONTINUE
          
cc CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
 
              
      ELSE IF ( NBTOT.GT.100.and.shift.eq.0.and.LORDER.eq.2) THEN
         write(*,*) 'L12 initial state in (111) plane'
         N = 1
         X = 1

         DO while(X.LE. NLCB)
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1 
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            I3 = I3 + 1
            I2 = I2 + 1
            if (mod(I3+I2,2).ne.0.and.mod(I1+I3,2).ne.0)then
               N = N + 1
               ID1D(X) = BID
            end if
            X = X + 1
         end do
            
         NDIF=NLCB/4-NBTOT
         N=1
         IF (NDIF.GT.0)THEN
            DO WHILE(N.LE.NDIF)
               X = 1 + INT(ALECOM() * NLCB)
               IPULL = IPULL + 1
               IF (ID1D(X).EQ.BID) THEN
                  ID1D(X)=AID
                  N=N+1
               ENDIF
            ENDDO   
         ELSE
            DO WHILE(N.LE.-NDIF)
               X = 1 + INT(ALECOM() * NLCB)
               IPULL = IPULL + 1
               IF (ID1D(X).EQ.AID) THEN
                  ID1D(X)=BID
                  N=N+1
               ENDIF
            ENDDO    
         ENDIF          
          
                
         DO 268 N = 1, NVTOT
 258        X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1 
            IF (ID1D(X).NE.AID) GOTO 258
            ID1D(X) = VID
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1 
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            LOCV(3, N) = I3 + 1
            LOCV(2, N) = I2 + 1
            LOCV(1, N) = I1
 268     CONTINUE


cc CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      ELSE IF ( NBTOT.GT.100.and.shift.eq.0.and.LORDER.eq.3) THEN
         write(*,*) 'L12/A1 initial state in (111) plane'
         X = 1
c   first set perfect L12 structure over all the lattice
         DO while(X.le. NLCB)
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            I3 = I3 + 1
            I2 = I2 + 1
            if (mod(I3+I2,2).ne.0.and.mod(I1+I3,2).ne.0)then
               ID1D(X) = BID
            end if
            X = X + 1
         end do
c   first set perfect L12 structure over all the lattice
c   ***************************************************************


c   secondly, randomly remove some B atom to set the concentration of B to 20.5%

  
         NDIF=NLCB/4-NLCB*0.205
         N=1
         DO WHILE(N.LE.NDIF)
            X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1
            IF (ID1D(X).EQ.BID) THEN
               ID1D(X)=AID
               N=N+1
            ENDIF
         ENDDO
c   secondly, randomly remove some B atom to set the concentration of B to 20.5%
c   ****************************************************************************

c   thirdly,  set the layer which start from point of NLCB/4+1 to NLCB/4+1+N
c   to be totally A atom
         N = NLCB * 0.53
         NDIF=0 
         DO X = NLCB/4 + 1 , NLCB/4+1+N 
            if(ID1D(X).eq.BID) NDIF=NDIF+1
            ID1D(X) = AID
         end do
c   thirdly,  set the layer which start from point of NLCB/4+1 to NLCB/4+1+N
c   to be totally A atom
c   ****************************************************************************

c   lastly, put all the rest of B atom to that layer
           
         NDIF = NBTOT- (NLCB*0.205 - NDIF)
           
         DO N = 1 , NDIF
 777        X = NLCB/4+1 + INT(ALECOM() * 0.53* NLCB)
            IPULL = IPULL + 1
            if(ID1D(X).ne.AID) goto 777 
            ID1D(X) = BID
         end do
  
c   lastly, put all the rest of B atom to that layer
c   *****************************************************************************

         DO 760 N = 1, NVTOT
 789        X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1
            IF (ID1D(X).NE.AID) GOTO 789
            ID1D(X) = VID
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            LOCV(3, N) = I3 + 1
            LOCV(2, N) = I2 + 1
            LOCV(1, N) = I1
 760     CONTINUE

C  *******************************************************************************
      ELSE IF ( NBTOT.GT.100.and.shift.eq.0.and.LORDER.eq.4) THEN
         write(*,*) 'L12/L10 initial state in (111) plane'
         X = 1

         DO while(X.le. NLCB)
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            I3 = I3 + 1
            I2 = I2 + 1
            if( mod(I3+I2,2).ne.0)then
               ID1D(X) = BID
            end if
            X = X + 1
         end do



         DO X = NLCB/4 + 1 , (3*NLCB)/4
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            I3 = I3 + 1
            I2 = I2 + 1
            ID1D(x) = AID
            if( mod(I3+I2,2).ne.0.and.mod(I1+I3,2).ne.0)then
               ID1D(X) = BID
            end if
         end do



         DO 770 N = 1, NVTOT
 779        X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1
            IF (ID1D(X).NE.AID) GOTO 779
            ID1D(X) = VID
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            LOCV(3, N) = I3 + 1
            LOCV(2, N) = I2 + 1
            LOCV(1, N) = I1
 770     CONTINUE
          NBTOT = 3*NLCB/8
  
C  *****************************************************************************           
        
           ELSE IF ( NBTOT.GT.100.and.shift.eq.0.and.LORDER.eq.5) THEN

            write(*,*) '2 layers of L12/L10 initial state '

            X = 1 

            do  while(X.le. NLCB)
 
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            I3 = I3 + 1
            I2 = I2 + 1
            if( mod(I3+I2,2).ne.0)then

            ID1D(X) = BID
            end if
            X = X + 1
            end do


           do N=1,2
           DO X = (NLCB*(4*N-3))/8 + 1 , (NLCB*(4*N-1))/8


            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            I3 = I3 + 1
            I2 = I2 + 1
            ID1D(x) = AID
            if( mod(I3+I2,2).ne.0.and.mod(I1+I3,2).ne.0)then

            ID1D(X) = BID
            end if
            end do
            end do

             DO 860 N = 1, NVTOT
 889          X = 1 + INT(ALECOM() * NLCB)
             IPULL = IPULL + 1
            IF (ID1D(X).NE.AID) GOTO 889
            ID1D(X) = VID
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            LOCV(3, N) = I3 + 1
            LOCV(2, N) = I2 + 1
            LOCV(1, N) = I1
 860       CONTINUE
           NBTOT = 3*NLCB/8


C   ***************************************************************************************    
      ELSE IF ( NBTOT.GT.100.and.shift.eq.0.and.LORDER.eq.6) THEN
         write(*,*) '4 layers of L12/L10 initial state'
         X = 1

         do while(X.le. NLCB)
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            I3 = I3 + 1
            I2 = I2 + 1
            if( mod(I3+I2,2).ne.0)then
               ID1D(X) = BID
            end if
            X = X + 1
         end do


         do N= 1, 4
            DO X = (NLCB*(2*N-1))/8 + 1 , (NLCB*N)/4
               I3 = (X - 1) / (NL1 * NL1)
               I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
               I1 = X - I3 * NL1 * NL1 - I2 * NL1
               I3 = I3 + 1
               I2 = I2 + 1
               ID1D(x) = AID
               if( mod(I3+I2,2).ne.0.and.mod(I1+I3,2).ne.0)then
                  ID1D(X) = BID
               end if
            end do
         end do
            
         DO  N = 1, NVTOT
 499        X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1
               
            IF (ID1D(X).NE.AID) GOTO 499
            
            ID1D(X) = VID
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            LOCV(3, N) = I3 + 1
            LOCV(2, N) = I2 + 1
            LOCV(1, N) = I1
         end do
         NBTOT = 3*NLCB/8

C *************************************************************************
      ELSE IF ( shift.eq.0.and.LORDER.eq.7) THEN
         write(*,*) ' " NBTOT" numbers of L10 and L12 blocks'
         X = 1

         DO  while(X.le. NLCB)
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            I3 = I3 + 1
            I2 = I2 + 1
            ID1D(X) = AID
            X = X + 1
         end do


         DO k1 = 1 , NL1/NBTOT
            DO k2 = 1 , NL1/NBTOT 
               DO k3 = 1 , NL2/NBTOT 
                  if(mod(k1+k2+k3,2).eq.0)then
           
                     do I1 =  NBTOT*(k1-1)+1, NBTOT*k1
                     do I2 =  NBTOT*(k2-1)+1, NBTOT*k2
                     do I3 =  NBTOT*(k3-1)+1, NBTOT*k3
                        if( mod(I3+I2,2).ne.0.and.mod(I1+I3,2).ne.0)then
                           X=I1+(I2-1)*NL1+(I3-1)*NL1*NL1
                           ID1D(X) = BID
                        end if
                     end do
                     end do 
                     end do
                  end if
               ENDDO
            ENDDO
         ENDDO 

         DO 870 N = 1, NVTOT
 879        X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1
            IF (ID1D(X).NE.AID) GOTO 879
            ID1D(X) = VID
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) /NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            LOCV(3, N) = I3 + 1
            LOCV(2, N) = I2 + 1
            LOCV(1, N) = I1
 870     CONTINUE

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c       for T=0.09 and c=0.15 
      ELSE IF ( NBTOT.GT.100.and.shift.eq.0.and.LORDER.eq.8) THEN
         write(*,*) 'bilay of L12/A1 initial state in (111) plane'
         X = 1
c   first set perfect L12 structure over all the lattice

         DO while(X.le. NLCB)
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            I3 = I3 + 1
            I2 = I2 + 1
            if (mod(I3+I2,2).ne.0.and.mod(I1+I3,2).ne.0)then
               ID1D(X) = BID
            end if
            X = X + 1
         end do
c   first set perfect L12 structure over all the lattice
c   ***************************************************************
c   ****************************************************************************

c   thirdly,  set the layer which start from point of NLCB/4+1 to NLCB/4+1+N
c   to be totally A atom

         N = NLCB * 0.53
         NDIF=0
         DO X = NLCB/4 + 1 , NLCB/4+1+N
            if (ID1D(X).eq.BID) NDIF=NDIF+1
            ID1D(X) = AID
         end do
c   thirdly,  set the layer which start from point of NLCB/4+1 to NLCB/4+1+N
c   to be totally A atom
c   ****************************************************************************
c   lastly, put all the rest of B atom to that layer

         NDIF = NBTOT- (NLCB*0.25 - NDIF)

         DO N = 1 , NDIF
 1777       X = NLCB/4+1 + INT(ALECOM() * 0.53* NLCB)
            IPULL = IPULL + 1
            if(ID1D(X).ne.AID) goto 1777
            ID1D(X) = BID
         end do

c   lastly, put all the rest of B atom to that layer
c   *****************************************************************************
         DO 1760 N = 1, NVTOT
 1789       X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1
            IF (ID1D(X).NE.AID) GOTO 1789
            ID1D(X) = VID
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            LOCV(3, N) = I3 + 1
            LOCV(2, N) = I2 + 1
            LOCV(1, N) = I1
 1760    CONTINUE
c   **************************************************************************



cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      for T=0.09, c=0.125  (v= 23%, concentration of B in L12 is 20.5%)
 
      ELSE IF ( NBTOT.GT.100.and.shift.eq.0.and.LORDER.eq.9) THEN
         X = 1
c   first set perfect L12 structure over all the lattice
         DO while(X.le. NLCB)
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            I3 = I3 + 1
            I2 = I2 + 1
  
            if( mod(I3+I2,2).ne.0.and.mod(I1+I3,2).ne.0)then
               ID1D(X) = BID
            end if
            X = X + 1
         end do
c   first set perfect L12 structure over all the lattice
c   ***************************************************************

c   secondly, randomly remove some B atom to set the concentration of B to 20.5%


         NDIF=NLCB/4-NLCB*0.205
         N=1
         DO WHILE(N.LE.NDIF)
            X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1
            IF (ID1D(X).EQ.BID) THEN
               ID1D(X)=AID
               N=N+1
            ENDIF
         ENDDO
c   secondly, randomly remove some B atom to set the concentration of B to 20.5%
c   ****************************************************************************

c   ****************************************************************************

c   thirdly,  set the layer which start from point of NLCB/8+1 to NLCB/8+1+N
c   to be totally A atom
         NDIF=0
         N = NLCB * 0.77
         DO X = NLCB/8 + 1 , NLCB/8+1+N
            if(ID1D(X).eq.BID) NDIF=NDIF+1
            ID1D(X) = AID
         end do
c   thirdly,  set the layer which start from point of NLCB/4+1 to NLCB/4+1+N
c   to be totally A atom
c   ****************************************************************************
c   lastly, put all the rest of B atom to that layer

         NDIF = NBTOT- (NLCB*0.205 - NDIF)

         DO N = 1 , NDIF
 1877       X = NLCB/8+1 + INT(ALECOM() * NLCB*0.77)
            IPULL = IPULL + 1
            if(ID1D(X).ne.AID) goto 1877
            ID1D(X) = BID
         end do
c   lastly, put all the rest of B atom to that layer
c   *****************************************************************************
         DO 1860 N = 1, NVTOT
 1889       X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1
            IF (ID1D(X).NE.AID) GOTO 1889
            ID1D(X) = VID
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            LOCV(3, N) = I3 + 1
            LOCV(2, N) = I2 + 1
            LOCV(1, N) = I1
 1860    CONTINUE
           
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c          for T=0.09, c=0.12( as volume fraction close to 17.5% and 
c           equilibrium concentration of B in L12 close to 0.205) 

c****************************************************************************
      ELSE IF ( NBTOT.GT.100.and.shift.eq.0.and.LORDER.eq.10) THEN
         write(*,*) '0.05, bilay of L12/A1 initial state in (111) plane'
         X = 1
c   first set perfect L12 structure over all the lattice
         N=1
         DO while(X.le. NLCB)
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            I3 = I3 + 1
            I2 = I2 + 1
  
            if( mod(I3+I2,2).ne.0.and.mod(I1+I3,2).ne.0)then
               N=N+1
               ID1D(X) = BID
            end if
            X = X + 1
         end do
c   first set perfect L12 structure over all the lattice
c   ***************************************************************

c   secondly, randomly remove some B atom to set the concentration of B to 20.5%

         NDIF=NLCB/4-NLCB*0.205
         N=1
         DO WHILE(N.LE.NDIF)
            X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1
            IF (ID1D(X).EQ.BID) THEN
               ID1D(X)=AID
               N=N+1
            ENDIF
         ENDDO
c   secondly, randomly remove some B atom to set the concentration of B to 24%
c   ****************************************************************************
c   ****************************************************************************

c   thirdly,  set the layer which start from point of NLCB/11+1 to NLCB/11+1+N
c   to be totally A atom
         NDIF=0
         AA = NL1 / 4
         AA2 = NL2 / 4
         BB =  AA+NL1*0.56
         BB2 = AA2+NL2*0.57
         DO X = 1 , NLCB
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            I3 = I3 + 1
            I2 = I2 + 1
            IF ((I1.lt.AA.or.I1.ge.BB).or.(I2.LT.AA.or.I2.GE.BB).
     /          or.(I3.LT.AA2.or.I3.GE.BB2)) then
               if(ID1D(X).eq.BID)  NDIF=NDIF+1
               ID1D(X) = AID
            ENDIF
         ENDDO
c   thirdly,  set the layer which start from point of NLCB/11+1 to NLCB/11+1+N
c   to be totally A atom
c   ****************************************************************************
c   lastly, put all the rest of B atom to that layer
         NDIF = NBTOT- (NLCB*0.205-NDIF)
         DO N = 1 , NDIF
 1977       X = INT(ALECOM() * NLCB)
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            I3 = I3 + 1
            I2 = I2 + 1
            IF (I1.Ge.AA.AND.I1.Lt.BB.AND.I2.Ge.AA.AND.I2.Lt.BB.
     /          AND.I3.Ge.AA2.AND.I3.Lt.BB2)  goto 1977 
               IPULL = IPULL + 1
            if(ID1D(X).ne.AID) goto 1977
            ID1D(X) = BID
         enddo
c   lastly, put all the rest of B atom to that layer
c   *****************************************************************************
         write(*,*) 'ipull=', IPULL, NDIF
         DO 1960 N = 1, NVTOT
 1989       X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1
            IF (ID1D(X).NE.AID) GOTO 1989
            ID1D(X) = VID
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            LOCV(3, N) = I3 + 1
            LOCV(2, N) = I2 + 1
            LOCV(1, N) = I1
 1960    CONTINUE
c *****************************************************************
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      ELSE IF ( NBTOT.GT.100.and.shift.eq.0.and.LORDER.eq.11) THEN
         write(*,*) 'L12/A1 initial state in (111) plane'
         X = 1
c   first set perfect L12 structure over all the lattice

         DO while(X.le. NLCB)
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            I3 = I3 + 1
            I2 = I2 + 1
            if (mod(I3+I2,2).ne.0.and.mod(I1+I3,2).ne.0) then
               ID1D(X) = BID
            end if
            X = X + 1
         end do
c   first set perfect L12 structure over all the lattice
c   ***************************************************************


c   secondly, randomly remove some B atom to set the concentration of B to 23%
         NDIF=NLCB/4-NLCB*0.23
         N=1
         DO WHILE(N.LE.NDIF)
            X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1
            IF (ID1D(X).EQ.BID) THEN
               ID1D(X)=AID
               N=N+1
            ENDIF
         ENDDO
c   secondly, randomly remove some B atom to set the concentration of B to 20.5%
c   ****************************************************************************

c   thirdly,  set the layer which start from point of NLCB/4+1 to NLCB/4+1+N
c   to be totally A atom

         N = NLCB * 0.5
         NDIF=0
         DO X = NLCB/4 + 1 , NLCB/4+1+N
            if(ID1D(X).eq.BID) NDIF=NDIF+1
            ID1D(X) = AID
         end do
c   thirdly,  set the layer which start from point of NLCB/4+1 to NLCB/4+1+N
c   to be totally A atom
c   ****************************************************************************

c   lastly, put all the rest of B atom to that layer

         NDIF = NBTOT- (NLCB*0.23 - NDIF)

         DO N = 1 , NDIF
 707        X = NLCB/4+1 + INT(ALECOM() * 0.5* NLCB)
            IPULL = IPULL + 1
            if(ID1D(X).ne.AID) goto 707
            ID1D(X) = BID
         end do

c   lastly, put all the rest of B atom to that layer
c   *****************************************************************************

         DO 2760 N = 1, NVTOT
 709        X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1
            IF (ID1D(X).NE.AID) GOTO 709
            ID1D(X) = VID
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            LOCV(3, N) = I3 + 1
            LOCV(2, N) = I2 + 1
            LOCV(1, N) = I1
 2760    CONTINUE

c *****************************************************************

      ELSEIF ( NBTOT.GT.100.and.shift.eq.0.and.LORDER.eq.12) THEN
c     Create a sphere with different variant in a perfect L12 structure
c     Added by Jia Ye, 12/09/2002 

c   ***************************************************************
c     first set perfect L12 structure over all the lattice
         X = 1
         DO while(X.le. NLCB)
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            I3 = I3 + 1
            I2 = I2 + 1
            if (mod(I3+I2,2).ne.0.and.mod(I1+I3,2).ne.0) then
               ID1D(X) = BID
            end if
            X = X + 1
         end do
c   ***************************************************************
C     Second FIND ALL THE B ATOMS WITHING SPHERE RANGE      

c     R in the unit of nearest neighbor distance
         R = 5.0
         NMX = 2 + INT(R) / 2
         DO I=1,16
             bran = 1 + int (ALECOM() * DFLOAT(NLCB) * (1.d0-tiny) ) 
	       IPULL = IPULL + 1
             CORE(3) = (bran - 1) / (NL1 * NL1)
             CORE(2) = ((bran - CORE(3) * NL1 * NL1) - 1) / NL1 
             CORE(1) = bran - CORE(3) * NL1 * NL1 - CORE(2) * NL1
             CORE(3) = CORE(3) + 1
             CORE(2) = CORE(2) + 1
             RN = 0  
             DO 1300 I1 = -NMX, NMX
             DO 1300 I2 = -NMX, NMX
             DO 1300 I3 = -NMX, NMX
                DO SUBL = 1, 4
                   IF (SUBL.EQ.1) THEN
                      N1 = 2 * I1
                      N2 = 2 * I2
                      N3 = 2 * I3
                   ELSE IF (SUBL.EQ.2) THEN         
                      N1 = 1 + 2 * I1
                      N2 = 1 + 2 * I2
                      N3 = 2 * I3
                   ELSE IF (SUBL.EQ.3) THEN         
                      N1 = 1 + 2 * I1
                      N2 = 2 * I2
                      N3 = 1 + 2 * I3
                   ELSE        
                      N1 = 2 * I1
                      N2 = 1 + 2 * I2
                      N3 = 1 + 2 * I3
                   END IF
             
                   MAGTDE = REAL(N1*N1) + REAL(N2*N2) + REAL(N3*N3)
                   MAGTDE = SQRT(MAGTDE/2.0)
                   IF (MAGTDE.LE.R) THEN
                      K1 = MODL1(CORE(1) + (N2 + N3 - N1) / 2)
                      K2 = MODL1(CORE(2) + (N1 + N3 - N2) / 2)
                      K3 = MODL1(CORE(3) + (N1 + N2 - N3) / 2)
                      X = K1 + (K2-1)*NL1 + (K3-1)*NL1*NL1
                      IF (ID1D(X).EQ.BID) THEN
                         RN = RN + 1
                         RANG(RN) = X
                      END IF
                   END IF
                END DO
 1300        CONTINUE

c   ***************************************************************
C     THIRD SWITCH B ATOMS WITH NEAREST NEIGHBOR
             DO N = 1, RN
                X = RANG(N)
                ID1D(X) = AID
                ID1D(X+1) = BID
             END DO
	   END DO
c   ***************************************************************
C     FINALLY PUT THE VACANCIES IN OUR SYSTEM
         DO 1710 N = 1, NVTOT
 1709       X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1
            IF (ID1D(X).NE.AID) GOTO 1709
            ID1D(X) = VID
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            LOCV(3, N) = I3 + 1
            LOCV(2, N) = I2 + 1
            LOCV(1, N) = I1
 1710    CONTINUE

c *****************************************************************

      ELSEIF ( NBTOT.GT.100.and.shift.eq.0.and.LORDER.eq.13) THEN
c     Create a ordered sphere in a disordered matrix
c     Added by Jia Ye, 12/12/2002 

c   ***************************************************************
c     first create disordered configuration

         DO 1320 N = 1, NBTOT
 1319       X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1
            IF (ID1D(X).NE.AID) GOTO 1319
            ID1D(X) = BID
 1320    CONTINUE

c   ***************************************************************
C     Second Create an ordered SPHERE      
         CORE(1)=NL1/2
         CORE(2)=CORE(1)
         CORE(3)=CORE(1)
         
         RN = 0 
c     R in the unit of nearest neighbor distance
         R = 25.0
         NMX = 2 + INT(R) / 2 
         DO 1395 I1 = -NMX, NMX
         DO 1395 I2 = -NMX, NMX
         DO 1395 I3 = -NMX, NMX
            DO 1390 SUBL = 1, 4
               IF (SUBL.EQ.1) THEN
                  N1 = 2 * I1
                  N2 = 2 * I2
                  N3 = 2 * I3
               ELSE IF (SUBL.EQ.2) THEN         
                  N1 = 1 + 2 * I1
                  N2 = 1 + 2 * I2
                  N3 = 2 * I3
               ELSE IF (SUBL.EQ.3) THEN         
                  N1 = 1 + 2 * I1
                  N2 = 2 * I2
                  N3 = 1 + 2 * I3
               ELSE        
                  N1 = 2 * I1
                  N2 = 1 + 2 * I2
                  N3 = 1 + 2 * I3
               END IF
             
               MAGTDE = REAL(N1*N1) + REAL(N2*N2) + REAL(N3*N3)
               MAGTDE = SQRT(MAGTDE/2.0)
               IF (MAGTDE.LE.R) THEN
                  K1 = CORE(1) + (N2 + N3 - N1) / 2
                  K2 = CORE(2) + (N1 + N3 - N2) / 2
                  K3 = CORE(3) + (N1 + N2 - N3) / 2
                  X = K1 + K2*NL1 + K3*NL1*NL1
                  if (mod(K3+K2,2).ne.0.and.mod(K1+K3,2).ne.0) then
                     ID1D(X) = BID
                  ELSE
                     ID1D(X) = AID
                  END IF
               END IF
 1390       CONTINUE
 1395    CONTINUE


c   ***************************************************************
C     FINALLY PUT THE VACANCIES IN OUR SYSTEM
         DO 1310 N = 1, NVTOT
 1309       X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1
            IF (ID1D(X).NE.AID) GOTO 1309
            ID1D(X) = VID
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            LOCV(3, N) = I3 + 1
            LOCV(2, N) = I2 + 1
            LOCV(1, N) = I1
 1310    CONTINUE

C  *******************************************************************************

      ELSE IF (NBTOT.EQ.1.AND.SHIFT.EQ.0) THEN
         WRITE (*,*) '(111) SLICE OF PURE B . '
c  Slice of pure B ; vacancies are put in pure A.    
         TIME = 0.0
         STEP = 0.0
         DO 250 X = NLCB/4 + 1 , (3*NLCB)/4
            ID1D(X) = BID
 250     CONTINUE
         DO 260 N = 1, NVTOT
 259        X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1 
            IF (ID1D(X).NE.AID) GOTO 259
            ID1D(X) = VID
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1 
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            LOCV(3, N) = I3 + 1
            LOCV(2, N) = I2 + 1
            LOCV(1, N) = I1
 260     CONTINUE
         NBTOT = NLCB / 2 

C  *******************************************************************************

      ELSE IF (NBTOT.EQ.1.AND.SHIFT.NE.0) THEN
         WRITE (*,*) ' Tilted (111) INTERFACE OF PURE B . '
c  layer of pure B ; vacancies are put in pure A.    
         TIME = 0.0
         STEP = 0.0
      DO 262 X = 1 , NLCB
         I3 = (X - 1) / (NL1 * NL1)
         I2 = ((X - I3 * NL1 * NL1) - 1) / NL1 
         I1 = X - I3 * NL1 * NL1 - I2 * NL1
         I3 = I3 + 1
         I2 = I2 + 1
         AA = NL2/2 + 1 + INT(REAL(I2-1)*REAL(SHIFT)/REAL(NL1))
         BB = NL2 + INT(REAL(I2-1)*REAL(SHIFT)/REAL(NL1))
         IF ( (I3.GE.AA.AND.I3.LE.BB).OR.
     /          ((I3-NL2).GE.AA.AND.(I3-NL2).LE.BB).OR.
     /          ((I3-2*NL2).GE.AA.AND.(I3-2*NL2).LE.BB).OR.
     /          ((I3-3*NL2).GE.AA.AND.(I3-3*NL2).LE.BB).OR.
     /          ((I3-4*NL2).GE.AA.AND.(I3-4*NL2).LE.BB).OR.
     /          ((I3+NL2).GE.AA.AND.(I3+NL2).LE.BB).OR.
     /          ((I3+2*NL2).GE.AA.AND.(I3+2*NL2).LE.BB).OR.
     /          ((I3+3*NL2).GE.AA.AND.(I3+3*NL2).LE.BB).OR.
     /          ((I3+4*NL2).GE.AA.AND.(I3+4*NL2).LE.BB) ) ID1D(X)=BID
 262     CONTINUE
         DO 266 N = 1, NVTOT
 264        X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1
            IF (ID1D(X).NE.AID) GOTO 264
            ID1D(X) = VID
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1 
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            LOCV(3, N) = I3 + 1
            LOCV(2, N) = I2 + 1
            LOCV(1, N) = I1
 266     CONTINUE
         NBTOT = NLCB / 2 

C  *******************************************************************************

      ELSE IF (NBTOT.EQ.2) THEN
         WRITE (*,*) 'PRECIPITATE OF PURE B . '
c  precipitate of pure B ; vacancies are put in pure A.    
         TIME = 0.0
         STEP = 0.0
         AA = NL1 / 4
         AA2 = NL2 / 4
         BB = 3 * AA
         BB2 = 3 * AA2
         DO 270 X = 1 , NLCB
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1 
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            I3 = I3 + 1
            I2 = I2 + 1
            IF (I1.GT.AA.AND.I1.LE.BB.AND.I2.GT.AA.AND.I2.LE.BB.
     /          AND.I3.GT.AA2.AND.I3.LE.BB2)  ID1D(X) = BID
 270     CONTINUE
         DO 280 N = 1, NVTOT
 279        X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1
            IF (ID1D(X).NE.AID) GOTO 279
            ID1D(X) = VID
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1 
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            LOCV(3, N) = I3 + 1
            LOCV(2, N) = I2 + 1
            LOCV(1, N) = I1
 280     CONTINUE
         NBTOT = NLCB / 2 

C  *******************************************************************************
 
      ELSE IF (NBTOT.EQ.3) THEN
         WRITE (*,*) '2 layers of A/B . '
c  2 Slices of pure B ; vacancies are put in pure A.    
         TIME = 0.0
         STEP = 0.0
         DO 305 N = 1, 2
            DO 310 X = (NLCB*(4*N-3))/8 + 1 , (NLCB*(4*N-1))/8
               ID1D(X) = BID
 310        CONTINUE
 305     CONTINUE
         DO 330 N = 1, NVTOT
 333        X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1
            IF (ID1D(X).NE.AID) GOTO 333
            ID1D(X) = VID
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1 
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            LOCV(3, N) = I3 + 1
            LOCV(2, N) = I2 + 1
            LOCV(1, N) = I1
 330     CONTINUE
         NBTOT = NLCB / 2 

C  *******************************************************************************

      ELSE IF (NBTOT.EQ.4) THEN
         WRITE (*,*) 'Multilayer A/B . '
c  4 Slices of pure B ; vacancies are put in pure A.    
         TIME = 0.0
         STEP = 0.0
         DO 500 N = 1, 4
            DO 510 X = (NLCB*(2*N-1))/8 + 1 , (N*NLCB)/4
               ID1D(X) = BID
 510        CONTINUE
 500     CONTINUE
         DO 600 N = 1, NVTOT
 599        X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1
            IF (ID1D(X).NE.AID) GOTO 599
            ID1D(X) = VID
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1 
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            LOCV(3, N) = I3 + 1
            LOCV(2, N) = I2 + 1
            LOCV(1, N) = I1
 600     CONTINUE
         NBTOT = NLCB / 2 

C  *******************************************************************************

      ELSE IF (NBTOT.EQ.5) THEN
         WRITE (*,*) 'SINE WAVE OF PURE B . '
c  Wave of pure B ; vacancies are put in pure A.    
         TIME = 0.0
         STEP = 0.0
         AMPL = 25
         DO 700 X = NLCB/4+AMPL*NL1*NL1+1,(3*NLCB)/4-AMPL*NL1*NL1
            ID1D(X) = BID
 700     CONTINUE
         DO 710 X=NLCB/4+1-AMPL*NL1*NL1,NLCB/4+AMPL*NL1*NL1
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1 
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            I3 = I3 + 1
            I2 = I2 + 1
            RI2 = REAL(I2) + REAL(I3)/3. 
            RI1 = REAL(I1) + REAL(I3)/3.
            RNL = REAL(NL1)
            XX = REAL(AMPL)*SIN(2.*Pi*RI1/RNL)*SIN(2.*Pi*RI2/RNL)
            AA = NL2 / 4 + NINT(XX)
            IF (I3.GT.AA)  ID1D(X) = BID
 710     CONTINUE
         DO 720 X=3*NLCB/4+1-AMPL*NL1*NL1,3*NLCB/4+AMPL*NL1*NL1
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1 
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            I3 = I3 + 1
            I2 = I2 + 1
            RI2 = REAL(I2) + REAL(I3)/3.  
            RI1 = REAL(I1) + REAL(I3)/3.
            RNL = REAL(NL1)
            XX = REAL(AMPL)*SIN(2.*Pi*RI1/RNL)*SIN(2.*Pi*RI2/RNL)
            AA = 3*NL2 / 4 + NINT(XX)
            IF (I3.LT.AA)  ID1D(X) = BID
 720     CONTINUE

         DO 750 N = 1, NVTOT
 749        X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1
            IF (ID1D(X).NE.AID) GOTO 749
            ID1D(X) = VID
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1 
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            LOCV(3, N) = I3 + 1
            LOCV(2, N) = I2 + 1
            LOCV(1, N) = I1
 750     CONTINUE
         NBTOT = NLCB / 2 

C  *******************************************************************************

      ELSE IF (NBTOT.EQ.6) THEN
         WRITE (*,*) ' (100) INTERFACE OF PURE B . '
c  layer of pure B ; vacancies are put in pure A.    
c  WARNING: work only if NL2 > 2*NL1
         TIME = 0.0
         STEP = 0.0
         AA = NL2 / 2
         DO 800 X = 1 , NLCB
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1 
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            I3 = I3 + 1
            I2 = I2 + 1
            IF ((I2+I3).GT.AA.AND.(I2+I3).LE.NL2) ID1D(X) = BID
 800     CONTINUE
         DO 810 N = 1, NVTOT
 809        X = 1 + INT(ALECOM() * NLCB)
            IPULL = IPULL + 1
            IF (ID1D(X).NE.AID) GOTO 809
            ID1D(X) = VID
            I3 = (X - 1) / (NL1 * NL1)
            I2 = ((X - I3 * NL1 * NL1) - 1) / NL1 
            I1 = X - I3 * NL1 * NL1 - I2 * NL1
            LOCV(3, N) = I3 + 1
            LOCV(2, N) = I2 + 1
            LOCV(1, N) = I1
 810     CONTINUE
         NBTOT = NLCB / 2 

C  *******************************************************************************
 
      ELSE
C Read the input configuration from a file.
c First skip N-1 conf's in this file.
         WRITE(*,*) 'READING CONFIGURATION FROM ', FCONIN
         OPEN(UNIT=LUCONIN,FILE=FCONIN,STATUS='OLD',FORM='UNFORMATTED')
         NBUF = 1 + (NLCB / (WORDLEN * BUFSIZ))
         NBAT=0
         NSKIP = - NBTOT
         DO 300 n = 1, NSKIP
            READ (LUCONIN,END=1111) TIME
            READ (LUCONIN,END=1111) BUFFER
            DO 290 BUF = 1,NBUF
               READ (LUCONIN,END=1111) BUFFER
 290        CONTINUE
 300     CONTINUE
 
         READ (LUCONIN,END=1111) TIME
         READ (LUCONIN,END=1111) BUFFER
         N = 1
         IPULL = BUFFER(N)
         N = 2
         NVTOT = BUFFER(N)
         DO 350 NVAC = 1, NVTOT
            I1 = BUFFER(N+1)
            I2 = BUFFER(N+2)
            I3 = BUFFER(N+3)
            VACLOC = (I3 - 1) * NL1 * NL1 + (I2 - 1) * NL1 + I1
            ID1D(VACLOC) = VID
            LOCV(1, NVAC) = I1
            LOCV(2, NVAC) = I2
            LOCV(3, NVAC) = I3
            IF ((VACLOC.LE.0).OR.(VACLOC.GE.NLCB)) WRITE (*,*) 'WHAT?'
            N = N+3
 350     CONTINUE
 
         DO 400 BUF = 1, NBUF
            READ (LUCONIN,END=1111) BUFFER
            BUFCOMP = (BUF - 1) * BUFSIZ * WORDLEN
            DO 390 WORD = 1, BUFSIZ
               WORDCOMP = (WORD - 1) * WORDLEN
               DO 380 BIT = 1, WORDLEN
                  BITPOS = WORDLEN - BIT
                  X = BUFCOMP + WORDCOMP + BIT
                  IF ((X.LE.NLCB).AND.(BTEST(BUFFER(WORD), BITPOS)))THEN
                     NBAT = NBAT + 1
                     ID1D(x) = BID
                  END IF
 380           CONTINUE
 390        CONTINUE
 400     CONTINUE
         CLOSE (UNIT = LUCONIN)
 
         NBTOT = NBAT
      END IF
 1111 WRITE (*,*) 'INITIAL CONFIGURATION DONE.'
 
      RETURN
      END


